;======================================================================
;								       
;		     Copyright (C) 1994-1995 by			       
;		  Production Languages Corporation	               
;			All Rights Reserved			       
;							 	       
;			    P.O. Box 109			       
;		    Weatherford, Texas 76086-0109		       
;			   (817) 599-8363		 	       
;								       
;
;========================================================================
;                                8x930Ax
;
;                             <8x930Ax.INC>
;
;=======================================================================*/
;


;       930Ax SFRs

; 930Ax uses IEN0 and IEN1 for registers and IE1 for TCON.3 bit
  IEN0    EQU    A8h
  IEN1    EQU    B1h

  IE1     EQU    0b000088h

  IPL1    EQU    B2h
  IPH1    EQU    B3h

  CH      EQU    F9h

  WCON    EQU    A7h
  PCON1   EQU    DFh

  FADDR   EQU    8Fh

  SOFL    EQU    D2h
  SOFH    EQU    D3h

  FIE     EQU    A2h
  FIFLG   EQU    C0h

  EPINDEX EQU    F1h
  EPCONFIG equ   C7h
  SIXEPPEN equ "EPCONFIG.0"
  EPCON   EQU    E1h
  RXSTAT  EQU    E2h
  RXDAT   EQU    E3h
  RXCON   EQU    E4h
  RXFLG   EQU    E5h
  RXCNTL  EQU    E6h
  RXCNTH  EQU    E7h
  TXSTAT  EQU    F2h
  TXDAT   EQU    F3h
  TXCON   EQU    F4h
  TXFLG   EQU    F5h
  TXCNTL  EQU    F6h
  TXCNTH  EQU    F7h


;       930Ax SFR bits

        EEP3    EQU     "IEN1.3"
        EEP2    EQU     "IEN1.2"
        EEP1    EQU     "IEN1.1"
        EEP0    EQU     "IEN1.0"

        PEP3L   EQU     "IPL1.3"
        PEP2L   EQU     "IPL1.2"
        PEP1L   EQU     "IPL1.1"
        PEP0L   EQU     "IPL1.0"

        PEP3H   EQU     "IPH1.3"
        PEP2H   EQU     "IPH1.2"
        PEP1H   EQU     "IPH1.1"
        PEP0H   EQU     "IPH1.0"

        RTWCE   EQU     "WCON.1"
        RTWE    EQU     "WCON.0"

        LC      EQU     "PCON.5"

        URDIS   EQU     "PCON1.4"
        URST    EQU     "PCON1.3"
        RWU     EQU     "PCON1.2"
        GRSM    EQU     "PCON1.1"
        GSUS    EQU     "PCON1.0"

        A6      EQU     "FADDR.6"
        A5      EQU     "FADDR.5"
        A4      EQU     "FADDR.4"
        A3      EQU     "FADDR.3"
        A2      EQU     "FADDR.2"
        A1      EQU     "FADDR.1"
        A0      EQU     "FADDR.0"

        TS7     EQU     "SOFL.7"
        TS6     EQU     "SOFL.6"
        TS5     EQU     "SOFL.5"
        TS4     EQU     "SOFL.4"
        TS3     EQU     "SOFL.3"
        TS2     EQU     "SOFL.2"
        TS1     EQU     "SOFL.1"
        TS0     EQU     "SOFL.0"

        SFACK   EQU     "SOFH.7"
        ASOF    EQU     "SOFH.6"
        SOFIE   EQU     "SOFH.5"
        FTLOCK  EQU     "SOFH.4"
        SOFODIS EQU     "SOFH.3"
        TS10    EQU     "SOFH.2"
        TS9     EQU     "SOFH.1"
        TS8     EQU     "SOFH.0"

        FRXIE3  EQU     "FIE.7"
        FTXIE3  EQU     "FIE.6"
        FRXIE2  EQU     "FIE.5"
        FTXIE2  EQU     "FIE.4"
        FRXIE1  EQU     "FIE.3"
        FTXIE1  EQU     "FIE.2"
        FRXIE0  EQU     "FIE.1"
        FTXIE0  EQU     "FIE.0"

        FRXD3   EQU     "FIFLG.7"
        FTXD3   EQU     "FIFLG.6"
        FRXD2   EQU     "FIFLG.5"
        FTXD2   EQU     "FIFLG.4"
        FRXD1   EQU     "FIFLG.3"
        FTXD1   EQU     "FIFLG.2"
        FRXD0   EQU     "FIFLG.1"
        FTXD0   EQU     "FIFLG.0"

        RXSTL   EQU     "EPCON.7"
        TXSTL   EQU     "EPCON.6"
        CTLEP   EQU     "EPCON.5"
        RXSPM   EQU     "EPCON.4"
        RXIE    EQU     "EPCON.3"
        RXEPEN  EQU     "EPCON.2"
        TXOE    EQU     "EPCON.1"
        TXEPEN  EQU     "EPCON.0"

        RXSEQ   EQU     "RXSTAT.7" 
        RXSETUP EQU     "RXSTAT.6"
        STOVW   EQU     "RXSTAT.5"
        EDOVW   EQU     "RXSTAT.4"
        RXDTO   EQU     "RXSTAT.3"
        RXVOID  EQU     "RXSTAT.2"
        RXERR   EQU     "RXSTAT.1"
        RXACK   EQU     "RXSTAT.0"

        RXCLR   EQU     "RXCON.7"
        RXWS    EQU     "RXCON.5"
        RXFFRC  EQU     "RXCON.4"
        RXISO   EQU     "RXCON.3"
        ARM     EQU     "RXCON.2"
        ADVWM   EQU     "RXCON.1"
        REVWP   EQU     "RXCON.0"

        RXFIF1  EQU     "RXFLG.7"
        RXFIF0  EQU     "RXFLG.6"
        RXEMP   EQU     "RXFLG.3"
        RXFULL  EQU     "RXFLG.2"
        RXURF   EQU     "RXFLG.1"
        RXOVF   EQU     "RXFLG.0"

        TXSEQ   EQU     "TXSTAT.7"
        TXFLUSH EQU     "TXSTAT.4"
        TXSOVW  EQU     "TXSTAT.3"
        TXVOID  EQU     "TXSTAT.2"
        TXERR   EQU     "TXSTAT.1"
        TXACK   EQU     "TXSTAT.0"

        TXCLR   EQU     "TXCON.7"
        FFSZ1   EQU     "TXCON.6"
        FFSZ0   EQU     "TXCON.5"
        TXISO   EQU     "TXCON.3"
        ATM     EQU     "TXCON.2"
        ADVRM   EQU     "TXCON.1"
        REVRP   EQU     "TXCON.0"

        TXFIF1  EQU     "TXFLG.7"
        TXFIF0  EQU     "TXFLG.6"
        TXEMP   EQU     "TXFLG.3"
        TXFULL  EQU     "TXFLG.2"
        TXURF   EQU     "TXFLG.1"
        TXOVF   EQU     "TXFLG.0"
PD EQU "PCON.1"
