;COMMENT /*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;**************************************************************************
;**                                                                      **
;**                  I N T E L   P R O P R I E T A R Y                   **
;**                                                                      **
;**     COPYRIGHT (c)  1996, 1997 BY  INTEL  CORPORATION.  ALL RIGHTS    **
;**     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      **
;**     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    **
;**     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    **
;**     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    **
;**     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    **
;**     THE PRIOR WRITTEN PERMISSION OF :                                **
;**                                                                      **
;**                        INTEL  CORPORATION                            **
;**                                                                      **
;**                     2200 MISSON COLLEGE BLVD                         **
;**                                                                      **
;**               SANTA  CLARA,  CALIFORNIA  95052-8119                  **
;**                                                                      **
;**$Author:   kschultz  $
;**$Modtime:   09 Sep 1996 13:42:48  $
;**$Revision:   1.0  $
;**************************************************************************
COMMENT /*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   (C) Copyright Intel Corp., 1996

   File: one_oh.inc

   Universal Serial Bus 930 Test firmware

   Revision History
   ---------------------------------------------
    0.3     05-16-97          Chip Linthicum (changed hub descr to 29)
    0.2     05-27-96          Abdul Rahman Ismail
    0.1     02-13-96          Joe DrAgony
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
;
; ONE_OH.INC: This file contains equates related to the operations under USB Spec. rev 1.0
;             It also includes equates for 82930 register manipulation
;

;<<<<<<<<<<<<<<
;bRequest Types
;>>>>>>>>>>>>>>

        GET_STATUS        equ 00h
        CLEAR_FEATURE     equ 01h
        GET_STATE         equ 02h
        SET_FEATURE       equ 03h
        RESERVED2         equ 04h
        SET_ADDRESS       equ 05h
        GET_DESCRIPTOR    equ 06h
        SET_DESCRIPTOR    equ 07h
        GET_CONFIGURATION equ 08h
        SET_CONFIGURATION equ 09h
        GET_INTERFACE     equ 0Ah
        SET_INTERFACE     equ 0Bh
        SYCH_FRAME        equ 0Ch

;<<<<<<<<<<<<<<;
;Descriptor Types
;>>>>>>>>>>>>>>
        DEVICE_DESCR            equ    01h
        CONFIG_DESCR            equ    02h
        STRING_DESCR            equ    03h
        INTERFACE_DESCR         equ    04h
        ENDPOINT_DESCR          equ    05h

;<<<<<<<<<<<<<<
;HID specific descriptor types
;>>>>>>>>>>>>>>
        HID_DESCR               equ    021h
        ENTITY_DESCR            equ    022h
        HUB_DESCR               equ    029h
;<<<<<<<<<<<<<<
;Feature Selectors
;>>>>>>>>>>>>>>


        DEVICE_REMOTE_WAKEUP   equ     01h
        ENDPOINT_STALL         equ     00h

;<<<<<<<<<<<<<<
;Recipient Selectors
;>>>>>>>>>>>>>>

        INTERFACE_TARGET       equ     01h
        ENDPOINT_TARGET        equ     02h
        OTHER_TARGET           equ     03h
        PORT_TARGET            equ     03h

;<<<<<<<<<<<<<<
;Stall Masks
;>>>>>>>>>>>>>>
        CLEAR_IN_STALL_MASK    equ     0BFH
        CLEAR_OUT_STALL_MASK   equ     07FH
        SET_IN_STALL_MASK      equ     040H
        SET_OUT_STALL_MASK     equ     080H

;
;Equates for clearing bits in SBI register
;


EP0_TX_CLR    equ  0FEh
EP0_RX_CLR    equ  0FDh

EP1_TX_CLR    equ  0FBh
EP1_RX_CLR    equ  0F7h

EP2_TX_CLR    equ  0EFh
EP2_RX_CLR    equ  0DFh

EP3_TX_CLR    equ  0BFh
EP3_RX_CLR    equ  07Fh

; --------------------------------
; ---  HUB COMMANDS
; --------------------------------

;HUB_BIT                         equ     EPINDEX.7

SUSPEND_EVENT_PENDING_FLAG:    equ 1h
SUSPEND_EVENT_EXECUTED_FLAG:   equ 2h

;Doug Equates.
;HEX_DSP_10      EQU     0ffe8h
;HEX_DSP_32      EQU     0ffe9h
;HEX_DSP_54      EQU     0ffeah
;HEX_DSP_76      EQU     0ffebh

C_HUB_LOCAL_POWER       EQU   0
C_HUB_OVER_CURRENT      EQU   1
PORT_CONNECTION         EQU   0
PORT_ENABLE             EQU   1
PORT_SUSPEND            EQU   2
PORT_OVER_CURRENT       EQU   3
PORT_RESET              EQU   4
PORT_POWER              EQU   8
PORT_LOW_SPEED          EQU   9
C_PORT_CONNECTION       EQU   16
C_PORT_ENABLE           EQU   17
C_PORT_SUSPEND          EQU   18
C_PORT_OVER_CURRENT     EQU   19
C_PORT_RESET            EQU   20


DISABLE_PORT_CMD        EQU   00h
ENABLE_PORT_CMD         EQU   01h
RESET_ENABLE_PORT_CMD   EQU   02h
SUSPEND_PORT_CMD        EQU   03h
RESUME_PORT_CMD         EQU   04h

CLEAR_PCSC_MASK         EQU  0FEh
CLEAR_PESC_MASK         EQU  0FDh
CLEAR_PSSC_MASK         EQU  0FBh
CLEAR_RSTSC_MASK        EQU  0EFH
CLEAR_OVISC_MASK        EQU  0F7h