;
; INCLUDE FILE FOR 51HX HUB
; This file contains the switches needed to convert between the
; 930HX PLC eval board, 51 part and simulator.
;
;

include "931masks.inc"
include "ONE_OH.INC"

ENABLED         equ     1
DISABLED        equ     0

; Equates used for switches
DONT_USE        equ     0
USE             equ     1

SIO_DEBUG       equ     DISABLED

RISM            equ     DISABLED        ; Note: you can't just enable this as
                                        ; you'll need to consider where data
                                        ; variables get moved to and might have to
                                        ; to change address mode for those values
CHUB            equ     ENABLED         ; CHUB directive:
                                        ;  If ENABLED, the LED0 light stays OFF until
                                        ;  set config 1 command
USE_SIMULATION  equ     DISABLED

DOUG            equ     DONT_USE

OVRI_DETECT     equ     ENABLED

KEYBOARD_CONFIG equ     33h
LOW_CLOCK_MODE  equ     DISABLED         ; set to ENABLED for 3 Mhz core
                                        ; set to DISABLED for 6 Mhz core
EMBEDDED_PORT_NUMBER    EQU    1h

HEARTBEAT_LED   equ     LED0            ; changed from LED3 to LED0 w/version 3.02
LED_PORT        equ     KBCON

SWITCH_PORT     equ     "P3"

ATTACHED_BIT    equ     "3"             ; Used to tell the program what port bit is the
                                        ; embedded function attached switch on
POWER_BIT       equ     "2"

KSO_STEP_TIME:  equ     600     ; Time that each KSO output is applied before
                                ; stepping to the next output.  Max value is
                                ; 255 uSeconds.  Each count equal 1 uSecond
                                ; Device   Value   KSO Scan Time
                                ; 251-LC    80     ~ 6.8 mSeconds
                                ; 251-HC    80     ~ 1.84 mSeconds
                                ; 251 HC   600     ~ 7 mSec

KSO_SCAN_TIME:  equ     8000    ; Keyswitch Matrix Scan interval.  If set to
                                ; 8000, the keyboad matrix is scanned every 8
                                ; 8000 uSeconds or 8 milliseconds. 64K is max value.

KEYBOARD_BUFFER_SIZE: equ 8     ; Number of key strokes to store.  Each keystroke takes
                                ; one bytes.



NO_KEY_PRESSED_CHAR:  equ 0FFh



IF USE_SIMULATION == ENABLED

SIMULATION_MODE1:   equ  ENABLED  ; If enabled, the embedded functioin is reset when a set configuration command is given.
SIMULATION_MODE2:   equ  ENABLED  ; If enabled, the embedded functioin is reset & Keyboard scanning begins at SOF=5.
FAKE_KEY_MODE1:     equ  ENABLED  ; If enabled, Fake keys are generated
ELSE
SIMULATION_MODE1:   equ  DISABLED  ; If enabled, the embedded functioin is reset when a set configuration command is given.
SIMULATION_MODE2:   equ  DISABLED  ; If enabled, the embedded functioin is reset & Keyboard scanning begins at SOF=5.
FAKE_KEY_MODE1:     equ  DISABLED  ; If enabled, Fake keys are generated
ENDIF