/*++

Copyright (c) 1997      Philips Semiconductors, APIC

Module Name:

        HIDUSAGE.H

Abstract:

   Public Definitions of Monitor Control HID USAGES.

Environment:

    Kernel & user mode

Revision History:

    May-1997 : created by Subhash B.

--*/

#ifndef   __HIDUSAGE_H__
#define   __HIDUSAGE_H__

//
// Usage pages
//

typedef USHORT USAGE, *PUSAGE;

#define HID_USAGE_PAGE_MONITOR		((USAGE) 0x80)
#define HID_USAGE_PAGE_ENUMVALUES	((USAGE) 0x82)
#define HID_USAGE_PAGE_VCP			((USAGE) 0x82)
#define HID_USAGE_PAGE_VESACOMMAND	((USAGE) 0x82)

#define HID_USAGE_MONITOR_CONTROL	((USAGE) 0x01)
#define HID_USAGE_MONITOR_EDID		((USAGE) 0x02)
#define HID_USAGE_MONITOR_VDIF		((USAGE) 0x03)
#define HID_USAGE_VESA_VERSION		((USAGE) 0x04)

#define HID_USAGE_ONSCREEN_DISPLAY	((USAGE) 0xCA)
#define HID_USAGE_AUTOSIZECENTRE	((USAGE) 0xA2)
#define HID_USAGE_POLARITY_HSYNC	((USAGE) 0xa4)
#define HID_USAGE_POLARITY_VSYNC	((USAGE) 0xa6)
#define HID_USAGE_SYNC_TYPE			((USAGE) 0xa8)
#define HID_USAGE_SCREEN_ORIENTATION ((USAGE) 0xAA)
#define HID_USAGE_HOR_FREQUENCY		((USAGE) 0xAC)
#define HID_USAGE_VER_FREQUENCY		((USAGE) 0xAE)

#define HID_USAGE_VCP_BRIGHTNESS	((USAGE) 0x10)
#define HID_USAGE_VCP_CONTRAST		((USAGE) 0x12)
#define HID_USAGE_VCP_FOCUS			((USAGE) 0x1c)
#define HID_USAGE_VCP_REDGAIN		((USAGE) 0x16)
#define HID_USAGE_VCP_GREENGAIN		((USAGE) 0x18)
#define HID_USAGE_VCP_BLUEGAIN		((USAGE) 0x1A)
#define HID_USAGE_VCP_HORPOS		((USAGE) 0x20)
#define HID_USAGE_VCP_HORSIZE		((USAGE) 0x22)
#define HID_USAGE_VCP_HORPIN		((USAGE) 0x24)
#define HID_USAGE_VCP_VERPOS		((USAGE) 0x30)
#define HID_USAGE_VCP_VERSIZE		((USAGE) 0x32)
#define HID_USAGE_VCP_VERPIN		((USAGE) 0x34)
#define HID_USAGE_VCP_PARALLELOGRAM ((USAGE) 0x40)
#define HID_USAGE_VCP_TILT			((USAGE) 0x44)
#define HID_USAGE_VCP_TRAPEZOID		((USAGE) 0x42)
#define HID_USAGE_VCP_RED			((USAGE) 0x6C)
#define HID_USAGE_VCP_GREEN			((USAGE) 0x6E)
#define HID_USAGE_VCP_BLUE			((USAGE) 0x70)

#define HID_USAGE_SETTINGS			((USAGE) 0xb0)
#define HID_USAGE_DEGAUSS			((USAGE) 0x01)
#define HID_USAGE_SECURITY_KEY		((USAGE) 0xFD)

#define HID_USAGE_PAGE_GENERIC    ((USAGE) 0x01)
#define HID_USAGE_PAGE_VEHICLE    ((USAGE) 0x02)
#define HID_USAGE_PAGE_VR         ((USAGE) 0x03)
#define HID_USAGE_PAGE_SPORT      ((USAGE) 0x04)
#define HID_USAGE_PAGE_GAME       ((USAGE) 0x05)
#define HID_USAGE_PAGE_CONSUMER   ((USAGE) 0x06)
#define HID_USAGE_PAGE_KEYBOARD   ((USAGE) 0x07)
#define HID_USAGE_PAGE_LED        ((USAGE) 0x08)
#define HID_USAGE_PAGE_BUTTON     ((USAGE) 0x09)
#define HID_USAGE_PAGE_ORDINAL    ((USAGE) 0x0A)
#define HID_USAGE_PAGE_TELEPHONY  ((USAGE) 0x0B)


#define ENUM_0		00
#define ENUM_1		01
#define ENUM_2		02
#define ENUM_3		03
#define ENUM_4		04
#define ENUM_5		05
#define ENUM_6		06

#endif

