/*++

Copyright (c) 1997      Philips Semiconductors, APIC

Module Name:

        VCPSTRUCT.H

Abstract:

   The Structures for the Monitor Control HID API calls.

Environment:

    Kernel & user mode

Revision History:

    Aug-1997 : created by Subhash B.

--*/

#ifndef VCPSTRUCT_H
#define VCPSTRUCT_H

#include "hidusage.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct _PHILIPS_MAINREPORT
{
	HANDLE		HidDeviceHandle;
	USHORT		UsagePage;
	USHORT		Usage; 
	PUCHAR		Buffer;
	PULONG		BufferLength;
}PHILIPS_MAINREPORT, *PPHILIPS_MAINREPORT;

typedef struct _RANGE_REPORT
{
	PLONG		LogicalMin;
	PLONG		LogicalMax;
	PUCHAR		EnumValues;
	PUCHAR		EnumCount;

}RANGE_REPORT, *PRANGE_REPORT;

typedef struct _AUX_REPORT
{
	PLONG		Reserved1;
	PLONG		Reserved2;

}AUX_REPORT, *PAUX_REPORT;

typedef struct _CALLBACK_APPLET_STRUCT
{

	DWORD				dwEvent;
	PPHILIPS_MAINREPORT pMainReport;
	PRANGE_REPORT		pRangeReport;
	PAUX_REPORT			pAuxReport;
	
}CALLBACK_APPLET_STRUCT, *PCALLBACK_APPLET_STRUCT;


#ifdef __cplusplus
}
#endif

#endif